Index: /autotranslator/pom.xml
===================================================================
--- /autotranslator/pom.xml	(revision 97)
+++ /autotranslator/pom.xml	(revision 98)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>python-autotranslator</artifactId>
-	<version>0.0.1</version>
+	<version>2.1.6</version>
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.12.3</jackson-2-version>
+		<j2p.version>1.0.0</j2p.version>
 		<geniusweb.version>${project.version}</geniusweb.version>
 	</properties>
@@ -31,42 +32,18 @@
 		<dependency>
 			<groupId>geniusweb</groupId>
-			<artifactId>party</artifactId>
+			<artifactId>issuevalue</artifactId>
 			<version>${geniusweb.version}</version>
 		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>profile</artifactId>
-			<version>${geniusweb.version}</version>
-		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>events</artifactId>
-			<version>${geniusweb.version}</version>
-		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>timeline</artifactId>
-			<version>${geniusweb.version}</version>
-		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>profileconnection</artifactId>
-			<version>${geniusweb.version}</version>
-		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>bidspace</artifactId>
-			<version>${geniusweb.version}</version>
-		</dependency>
-		<dependency>
-			<groupId>geniusweb</groupId>
-			<artifactId>opponentmodel</artifactId>
-			<version>${geniusweb.version}</version>
-		</dependency>
-
-		<dependency>
-			<groupId>tudelft.utilities</groupId>
-			<artifactId>logging</artifactId>
-			<version>1.0.1</version>
+
+
+		<dependency>
+			<groupId>tudelft.utilities.j2p</groupId>
+			<artifactId>core</artifactId>
+			<version>${j2p.version}</version>
+		</dependency>
+		<dependency>
+			<groupId>tudelft.utilities.j2p</groupId>
+			<artifactId>jackson-t</artifactId>
+			<version>${j2p.version}</version>
 		</dependency>
 
@@ -96,5 +73,5 @@
 		</repository>
 	</repositories>
-	
+
 	<pluginRepositories>
 		<pluginRepository>
@@ -115,4 +92,30 @@
 			<plugin>
 				<groupId>org.apache.maven.plugins</groupId>
+				<artifactId>maven-dependency-plugin</artifactId>
+				<executions>
+					<execution>
+						<id>unpack</id>
+						<phase>validate</phase>
+						<goals>
+							<goal>unpack</goal>
+						</goals>
+						<configuration>
+							<artifactItems>
+								<artifactItem>
+									<groupId>geniusweb</groupId>
+									<artifactId>issuevalue</artifactId>
+									<version>${geniusweb.version}</version>
+									<type>jar</type>
+									<outputDirectory>downloads</outputDirectory>
+								</artifactItem>
+							</artifactItems>
+						</configuration>
+					</execution>
+				</executions>
+			</plugin>
+
+
+			<plugin>
+				<groupId>org.apache.maven.plugins</groupId>
 				<artifactId>maven-compiler-plugin</artifactId>
 				<version>3.8.0</version>
@@ -148,17 +151,17 @@
 			</plugin>
 
-			<plugin>
-				<groupId>org.apache.maven.plugins</groupId>
-				<artifactId>maven-javadoc-plugin</artifactId>
-				<version>3.2.0</version>
-				<executions>
-					<execution>
-						<id>attach-javadocs</id>
-						<goals>
-							<goal>jar</goal>
-						</goals>
-					</execution>
-				</executions>
-			</plugin>
+<!-- 			<plugin> -->
+<!-- 				<groupId>org.apache.maven.plugins</groupId> -->
+<!-- 				<artifactId>maven-javadoc-plugin</artifactId> -->
+<!-- 				<version>3.2.0</version> -->
+<!-- 				<executions> -->
+<!-- 					<execution> -->
+<!-- 						<id>attach-javadocs</id> -->
+<!-- 						<goals> -->
+<!-- 							<goal>jar</goal> -->
+<!-- 						</goals> -->
+<!-- 					</execution> -->
+<!-- 				</executions> -->
+<!-- 			</plugin> -->
 
 			<plugin>
Index: /autotranslator/src/main/java/Try.java
===================================================================
--- /autotranslator/src/main/java/Try.java	(revision 98)
+++ /autotranslator/src/main/java/Try.java	(revision 98)
@@ -0,0 +1,8 @@
+
+/**
+ * First attempt at translating a original geniusweb package to python
+ * automatically
+ */
+public class Try {
+
+}